/*
 * Copyright (C) 2019  Max Regan
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */


#pragma once

#include "Bsp/macros.h"

#include "Application/SystemFonts.h"
#include "Application/ScreenManager.h"
#include "Application/Screens/Screen.h"

class DebugScreen : public Screen {
public:

    static constexpr std::size_t MAX_ITEMS = 10;

    DebugScreen(BSP::DisplayDriver &display,
                ScreenManager &manager)
        : m_driver(display)
        , m_manager(manager)
                {}

    BSP::ReturnCode init() {
        return BSP::ReturnCode::OK;
    }

    void render() {
        const struct font &font = default_font;
        char buffer[32] = {0};

        m_driver.clear();

        uint32_t x = 0;
        uint32_t y = 0;
        // snprintf(buffer, sizeof(buffer), "Wakeups");
        m_driver.string_at(&x, y, buffer, &font);
        y += font.height;

        m_driver.refresh();
    }

    BSP::Schedule::NextTime execute() override {
        render();
        return BSP::Schedule::NextTime::never();
    }

    void enable() override {
        render();
    }

    void disable() override {
        m_driver.clear();
    }

    void notify_up_button() override {
    }

    void notify_middle_button() override {
        m_manager.pop_screen();
    }

    void notify_down_button() override {
        m_manager.pop_screen();
    }

private:

    BSP::DisplayDriver &m_driver;
    ScreenManager &m_manager;
};
